::
:: SyncPro Startup Script for Windows
::
@echo off
cls
:: Set the memory usage for the java program
SET JVM_ARGS=-Xms256m -Xmx1024m
SET JVM_ARGS=%JVM_ARGS% 

:: Set Java Home Path manually if neccessary
SET JAVA_HOME=

:: Automatically detect and set JAVA_HOME
SET MinimumRequiredJavaVersion=1.6
if "%JAVA_HOME%" == "" (
	goto WithoutJavaHome
) ELSE (
	goto WithJavaHome
)

:WithJavaHome
echo Using a given Java home path to run Java
SET JAVA_EXE=%JAVA_HOME%\bin\java.exe
IF NOT EXIST "%JAVA_EXE%" goto TrySystemBin
"%JAVA_EXE%" -version 2>java_version.txt
:: Detect if the current java version fulfill minimum java runtime environment for the program
for /f "tokens=3" %%i in (java_version.txt) do (
	if %%i LEQ "%MinimumRequiredJavaVersion%" goto ERROR_MINIMUM_JAVA_VERSION
)
:: Get Current Java Version, extract the first token
for /f "tokens=3" %%i in (java_version.txt) do (
	SET CURRENT_VERSION=%%i
	goto START_JAVA_PROGRAM
)
goto START_JAVA_PROGRAM

:WithoutJavaHome
:: Set the registry path to find the java path
SET KeyName=HKLM\Software\JavaSoft\Java Runtime Environment
SET Cmd=reg query "%KeyName%" /s
echo Try to search for registry key of Java
:: Detect and set JAVA_HOME
FOR /f "tokens=2*" %%i in ('%Cmd% ^| find "JavaHome"') do SET JAVA_HOME=%%j
IF "%JAVA_HOME%" == "" (goto TrySystemBin)
FOR /f "tokens=2*" %%i in ('%Cmd% ^| find "CurrentVersion"') do SET CURRENT_VERSION=%%j
:: Detect if the current java version fulfill minimum java runtime environment for the program
IF /I %CURRENT_VERSION% GEQ %MinimumRequiredJavaVersion% (
	SET JAVA_EXE=%JAVA_HOME%\bin\java.exe
	IF NOT EXIST "%JAVA_EXE%" goto TrySystemBin
	goto START_JAVA_PROGRAM
	) ELSE (
	goto ERROR_MINIMUM_JAVA_VERSION
)
goto START_JAVA_PROGRAM

:TrySystemBin
echo Try System Bin to launch Java
SET JAVA_HOME=
SET JAVA_EXE=java.exe
"%JAVA_EXE%" -version 2>java_version.txt
:: Detect if the current java version fulfill minimum java runtime environment for the program
for /f "tokens=3" %%i in (java_version.txt) do (
	if %%i LEQ "%MinimumRequiredJavaVersion%" goto ERROR_MINIMUM_JAVA_VERSION
)
:: Get Current Java Version, extract the first token
for /f "tokens=3" %%i in (java_version.txt) do (
	SET CURRENT_VERSION=%%i
	goto START_JAVA_PROGRAM
)
goto START_JAVA_PROGRAM

:START_JAVA_PROGRAM
echo JavaHome : %JAVA_HOME%
echo Current Java Runtime Environment Version : %CURRENT_VERSION%

SET PROGRAM_HOME=.
SET MAIN_CLASS=Main

SET OLD_PATH=%PATH%
SET PATH=%PROGRAM_HOME%;%PATH%

:: Setting Current Path
SET CLASS_PATH=%PROGRAM_HOME%\SyncPro.jar

:: Setting my doggy 1.4.2 class path
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\mydoggy-1.4.2\mydoggy-api-1.4.2.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\mydoggy-1.4.2\mydoggy-plaf-1.4.2.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\mydoggy-1.4.2\mydoggy-res-1.4.2.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\mydoggy-1.4.2\TableLayout-20050920.jar

:: Setting dom4j 1.6.1 class path
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\dom4j-1.6.1\dom4j-1.6.1.jar

:: Setting gdswing class path
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\gdswing\gdswing.jar

:: Setting jfreeChart 1.0.11 class path
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\jfreechart\jcommon-1.0.16.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\jfreechart\jfreechart-1.0.13.jar

:: Setting Jrap class path
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\Jrap\jakarta-regexp-1.4.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\Jrap\jrap_3.0.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\Jrap\jrap-dist.jar

:: Setting xerces class path (Run time lib for Jrap)
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\xerces\resolver.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\xerces\xercesImpl.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\xerces\xercesSamples.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\xerces\xml-apis.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\xerces\xmlParserAPIs.jar

:: Setting Log4j class path
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\apache-log4j-1.2.15\log4j-1.2.15.jar

:: Setting Apache commons math 2.0 class path
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\apache-commons-math-2.0\commons-math-2.0.jar

::Setting Apache commons configuration 1.6 class path and its dependencies
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\apache-commons-configuration-1.6\commons-configuration-1.6.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\apache-commons-configuration-1.6\commons-lang-2.5.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\apache-commons-configuration-1.6\commons-collections-3.2.1.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\apache-commons-configuration-1.6\commons-logging-1.1.1.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\apache-commons-configuration-1.6\commons-digester-2.0.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\apache-commons-configuration-1.6\commons-beanutils-1.8.2.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\apache-commons-configuration-1.6\commons-beanutils-bean-collections-1.8.2.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\apache-commons-configuration-1.6\commons-beanutils-core-1.8.2.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\apache-commons-configuration-1.6\commons-codec-1.4.jar
SET CLASS_PATH=%CLASS_PATH%;%PROGRAM_HOME%\lib\apache-commons-configuration-1.6\commons-jxpath-1.3.jar

echo "%JAVA_EXE%" %JVM_ARGS% -cp "%CLASS_PATH%" %MAIN_CLASS% %*
"%JAVA_EXE%" %JVM_ARGS% -cp "%CLASS_PATH%" %MAIN_CLASS% %*

SET PATH=%OLD_PATH%

goto END
:ERROR_MINIMUM_JAVA_VERSION
	echo ERROR: cannot start SyncPro.
	echo Please validate if Java Runtime Environment (Version: %MinimumRequiredJavaVersion%) is installed.
	echo You may get the latest version of Java at http://java.sun.com/javase/downloads/index.jsp
	pause
	goto END
:END
IF EXIST java_version.txt DEL java_version.txt